%   DRONE_TRAINING1

%	Trains on the data. Uses all other files in the folder for generating
%	histogam and using SVM classifier.
%   Data (pictures) should be present in the "data/images/" folder in the 
%   working directory. The path is hard coded to various building.

%	Author Dhruv Kumar Yadav and Smith Gupta

setup;
%--------------------------------------------------------------------------
%--------------------------DATA PREPERATION--------------------------------
%--------------------------------------------------------------------------
%IME
IME_Front.names=getImageSet('data/images/IME_Front');
IME_Back.names=getImageSet('data/images/IME_Back');
IME.names=[IME_Front.names IME_Back.names];

%Kadim
Kadim_Front.names=getImageSet('data/images/Kadim_Front');
Front_Right_Names=getImageSet('data/images/Kadim_Front_Right');
Right_Names=getImageSet('data/images/Kadim_Right');
Kadim_Right.names=[Front_Right_Names Right_Names];
Kadim.names=[Kadim_Front.names Kadim_Right.names];
clear Front_Right_Names Right_Names;

%Library
Library_Side.names=getImageSet('data/images/Library_Side');
Library_Back.names=getImageSet('data/images/Library_Back');
Library.names=[Library_Side.names Library_Back.names];


names=[IME.names Kadim.names Library.names];

vocabulary=computeVocabularyFromImageList(names);

% Compute histograms from IME images
IME.histograms = computeHistogramsFromImageList(vocabulary, IME.names, 'data/cache') ;
IME_Front.histograms =computeHistogramsFromImageList(vocabulary, IME_Front.names, 'data/cache');
IME_Back.histograms= computeHistogramsFromImageList (vocabulary, IME_Back.names, 'data/cache');

% Compute histograms from KADIM images
Kadim.histograms = computeHistogramsFromImageList(vocabulary, Kadim.names, 'data/cache') ;
Kadim_Front.histograms =computeHistogramsFromImageList (vocabulary, Kadim_Front.names, 'data/cache');
Kadim_Right.histograms =computeHistogramsFromImageList (vocabulary, Kadim_Right.names, 'data/cache');
%Kadim_Front_Right.histograms =computeHistogramsFromImageList (vocabulary, Kadim_Front_Right, 'data/cache');

% Compute histograms from Library images
Library.histograms= computeHistogramsFromImageList(vocabulary, Library.names, 'data/cache');
Library_Side.histograms=computeHistogramsFromImageList(vocabulary, Library_Side.names, 'data/cache');
Library_Back.histograms=computeHistogramsFromImageList(vocabulary, Library_Back.names, 'data/cache');



%clear names_IME names_Kadim names_FB;

%********************************************************************************
%************************TRAINING atLevel 1**************************************
%********************************************************************************

C = 100 ;

% TRAINING For Positive IME and Negative KADIM
histograms_IME_Kadim = [IME.histograms, Kadim.histograms] ;
labels_IME_Kadim = [ones(1,numel(IME.names)), - ones(1,numel(Kadim.names))] ;
names_IME_Kadim = [IME.names  Kadim.names];
histograms_IME_Kadim = sqrt(histograms_IME_Kadim) ;
fprintf('Number of training images: %d positive, %d negative\n', ...
        sum(labels_IME_Kadim > 0), sum(labels_IME_Kadim < 0)) ;

lambda_IME_Kadim = 1 / (C * numel(labels_IME_Kadim)) ;
w_IME_Kadim= vl_svmtrain(histograms_IME_Kadim,labels_IME_Kadim,lambda_IME_Kadim);
scores_IME_Kadim = w_IME_Kadim' * histograms_IME_Kadim;
% Visualize the ranked list of images
% figure(1) ; clf ; set(1,'name','Ranked training images (subset)') ;
% displayRankedImageList(names, scores)  ;



% TRAINING For Positive IME and Negative Library
histograms_IME_Library = [IME.histograms, Library.histograms] ;
labels_IME_Library = [ones(1,numel(IME.names)), - ones(1,numel(Library.names))] ;
names_IME_Library = [IME.names  Library.names];
histograms_IME_Library = sqrt(histograms_IME_Library) ;
fprintf('Number of training images: %d positive, %d negative\n', ...
        sum(labels_IME_Library > 0), sum(labels_IME_Library < 0)) ;

lambda_IME_Library = 1 / (C * numel(labels_IME_Library)) ;
w_IME_Library= vl_svmtrain(histograms_IME_Library,labels_IME_Library,lambda_IME_Library);
scores_IME_Library = w_IME_Library' * histograms_IME_Library;


% TRAINING For Positive Kadim and Negative Library
histograms_Kadim_Library = [Kadim.histograms, Library.histograms] ;
labels_Kadim_Library = [ones(1,numel(Kadim.names)), - ones(1,numel(Library.names))] ;
names_Kadim_Library = [Kadim.names  Library.names];
histograms_Kadim_Library = sqrt(histograms_Kadim_Library) ;
fprintf('Number of training images: %d positive, %d negative\n', ...
        sum(labels_Kadim_Library > 0), sum(labels_Kadim_Library < 0)) ;

lambda_Kadim_Library = 1 / (C * numel(labels_Kadim_Library)) ;
w_Kadim_Library= vl_svmtrain(histograms_Kadim_Library,labels_Kadim_Library,lambda_Kadim_Library);
scores_Kadim_Library = w_Kadim_Library' * histograms_Kadim_Library;

%********************************************************************************
%************************TRAINING at Level 2*************************************
%********************************************************************************
% TRAINING For Positive Front IME and Negative Back IME
histograms_IME_Front_Back = [IME_Front.histograms , IME_Back.histograms] ;
labels_IME_Front_Back = [ones(1,numel(IME_Front.names)), - ones(1,numel(IME_Back.names))] ;
names_IME_Front_Back = [IME_Front.names  IME_Back.names];
histograms_IME_Front_Back = sqrt(histograms_IME_Front_Back) ;
fprintf('Number of training images: %d positive, %d negative\n', ...
        sum(labels_IME_Front_Back > 0), sum(labels_IME_Front_Back < 0)) ;

lambda_IME_Front_Back = 1 / (C * numel(labels_IME_Front_Back)) ;
w_IME_Front_Back= vl_svmtrain(histograms_IME_Front_Back,labels_IME_Front_Back,lambda_IME_Front_Back);
scores_IME_Front_Back = w_IME_Front_Back' * histograms_IME_Front_Back;

% TRAINING For Positive Side Library and Negative Back Library
histograms_Library_Side_Back = [Library_Side.histograms , Library_Back.histograms] ;
labels_Library_Side_Back = [ones(1,numel(Library_Side.names)), - ones(1,numel(Library_Back.names))] ;
names_Library_Side_Back = [Library_Side.names  Library_Back.names];
histograms_Library_Side_Back = sqrt(histograms_Library_Side_Back) ;
fprintf('Number of training images: %d positive, %d negative\n', ...
        sum(labels_Library_Side_Back > 0), sum(labels_Library_Side_Back < 0)) ;

lambda_Library_Side_Back = 1 / (C * numel(labels_Library_Side_Back)) ;
w_Library_Side_Back= vl_svmtrain(histograms_Library_Side_Back,labels_Library_Side_Back,lambda_Library_Side_Back);
scores_Library_Side_Back = w_Library_Side_Back' * histograms_Library_Side_Back;

% TRAINING For Positive Front Kadim and Negative Right Kadim
histograms_Kadim_Front_Right = [Kadim_Front.histograms , Kadim_Right.histograms] ;
labels_Kadim_Front_Right = [ones(1,numel(Kadim_Front.names)), - ones(1,numel(Kadim_Right.names))] ;
names_Kadim_Front_Right = [Kadim_Front.names  Kadim_Right.names];
histograms_Kadim_Front_Right = sqrt(histograms_Kadim_Front_Right) ;
fprintf('Number of training images: %d positive, %d negative\n', ...
        sum(labels_Kadim_Front_Right > 0), sum(labels_Kadim_Front_Right < 0)) ;

lambda_Kadim_Front_Right = 1 / (C * numel(labels_Kadim_Front_Right)) ;
w_Kadim_Front_Right= vl_svmtrain(histograms_Kadim_Front_Right,labels_Kadim_Front_Right,lambda_Kadim_Front_Right);
scores_Kadim_Front_Right = w_Kadim_Front_Right' * histograms_Kadim_Front_Right;

%clear lambda



[Prob_IME_given_IME_Library, Prob_Library_given_IME_Library]=calculate_Prob(scores_IME_Library, labels_IME_Library);
[Prob_IME_given_IME_Kadim, Prob_Kadim_given_IME_Kadim]=calculate_Prob(scores_IME_Kadim, labels_IME_Kadim);
[Prob_Kadim_given_Kadim_Library, Prob_Library_given_Kadim_Library]=calculate_Prob(scores_Kadim_Library, labels_Kadim_Library);

Prob_IME_given_IME_Library=cell2mat(struct2cell(Prob_IME_given_IME_Library));
Prob_Library_given_IME_Library=cell2mat(struct2cell(Prob_Library_given_IME_Library));
Prob_IME_given_IME_Kadim=cell2mat(struct2cell(Prob_IME_given_IME_Kadim));
Prob_Kadim_given_IME_Kadim=cell2mat(struct2cell(Prob_Kadim_given_IME_Kadim));
Prob_Kadim_given_Kadim_Library=cell2mat(struct2cell(Prob_Kadim_given_Kadim_Library));
Prob_Library_given_Kadim_Library=cell2mat(struct2cell(Prob_Library_given_Kadim_Library));

% figure(1) ; clf ; set(1,'name','IME VS KADIM Ranked training images (subset)') ;
% displayRankedImageList(names_IME_Kadim, scores_IME_Kadim)  ;
% figure(2) ; clf ; set(2,'name','IME VS Library Ranked training images (subset)') ;
% displayRankedImageList(names_IME_Library, scores_IME_Library)  ;
% figure(3) ; clf ; set(3,'name','KADIM VS Library Ranked training images (subset)') ;
% displayRankedImageList(names_Kadim_Library, scores_Kadim_Library)  ;
