%   NORMALISE
%   This smooths the probability mass function with each zero probability is 
%   given mean of its neighbours.

%   Author:: Dhurv Kumar Yadav
function Prob= Normalise(Prob)

if(Prob.Prob_0_1==0)
    Prob.Prob_0_1=(Prob.Prob_1_2+Prob.Prob_minus1_0)/2;
end
if(Prob.Prob_1_2==0)
    Prob.Prob_1_2=(Prob.Prob_2_3+Prob.Prob_0_1)/2;
end
if(Prob.Prob_2_3==0)
    Prob.Prob_2_3=(Prob.Prob_3_4+Prob.Prob_1_2)/2;
end
if(Prob.Prob_3_4==0)
    Prob.Prob_3_4=(Prob.Prob_4_5+Prob.Prob_2_3)/2;
end
if(Prob.Prob_4_5==0)
    Prob.Prob_4_5=(Prob.Prob_5_6 + Prob.Prob_3_4)/2;
end
if(Prob.Prob_5_6==0)
    Prob.Prob_5_6=(Prob.Prob_6_7 + Prob.Prob_4_5)/2;
end
if(Prob.Prob_6_7==0)
    Prob.Prob_6_7=(Prob.Prob_7_8 +Prob.Prob_5_6)/2;
end
if(Prob.Prob_7_8==0)
    Prob.Prob_7_8=(Prob.Prob_8_9 +Prob.Prob_6_7)/2;
end
if(Prob.Prob_8_9==0)
    Prob.Prob_8_9=(Prob.Prob_9_10 +Prob.Prob_7_8)/2;
end
if(Prob.Prob_9_10==0)
    Prob.Prob_9_10=(Prob.Prob_geq_10 +Prob.Prob_8_9)/2;
end
if(Prob.Prob_geq_10==0)
    Prob.Prob_geq_10=(Prob.Prob_9_10)/2;
end
if(Prob.Prob_minus1_0==0)
    Prob.Prob_minus1_0=(Prob.Prob_0_1 +Prob.Prob_minus2_minus1)/2;
end
if(Prob.Prob_minus2_minus1==0)
    Prob.Prob_minus2_minus1=(Prob.Prob_minus1_0 +Prob.Prob_minus3_minus2)/2;
end
if(Prob.Prob_minus3_minus2==0)
    Prob.Prob_minus3_minus2=(Prob.Prob_minus2_minus1 +Prob.Prob_minus4_minus3)/2;
end
if(Prob.Prob_minus4_minus3==0)
    Prob.Prob_minus4_minus3=(Prob.Prob_minus3_minus2 +Prob.Prob_minus5_minus4)/2;
end
if(Prob.Prob_minus5_minus4==0)
    Prob.Prob_minus5_minus4=(Prob.Prob_minus4_minus3 +Prob.Prob_minus6_minus5)/2;
end
if(Prob.Prob_minus6_minus5==0)
    Prob.Prob_minus6_minus5=(Prob.Prob_minus5_minus4 +Prob.Prob_minus7_minus6)/2;
end
if(Prob.Prob_minus7_minus6==0)
    Prob.Prob_minus7_minus6=(Prob.Prob_minus6_minus5 +Prob.Prob_minus8_minus7)/2;
end
if(Prob.Prob_minus8_minus7==0)
    Prob.Prob_minus8_minus7=(Prob.Prob_minus7_minus6 +Prob.Prob_minus9_minus8)/2;
end
if(Prob.Prob_minus9_minus8==0)
    Prob.Prob_minus9_minus8=(Prob.Prob_minus8_minus7 +Prob.Prob_minus10_minus9)/2;
end
if(Prob.Prob_minus10_minus9==0)
    Prob.Prob_minus10_minus9=(Prob.Prob_minus9_minus8 +Prob.Prob_leq_minus10)/2;
end
if(Prob.Prob_leq_minus10==0)
    Prob.Prob_leq_minus10=Prob.Prob_minus10_minus9/2;
end

sumi=Prob.Prob_0_1+Prob.Prob_1_2+Prob.Prob_2_3+Prob.Prob_3_4+Prob.Prob_4_5+Prob.Prob_5_6+Prob.Prob_6_7+Prob.Prob_7_8+...
        Prob.Prob_8_9+Prob.Prob_9_10+Prob.Prob_geq_10+Prob.Prob_minus1_0+ Prob.Prob_minus2_minus1+Prob.Prob_minus3_minus2+...
        Prob.Prob_minus4_minus3+Prob.Prob_minus5_minus4+Prob.Prob_minus6_minus5+Prob.Prob_minus7_minus6+Prob.Prob_minus8_minus7+...
        Prob.Prob_minus9_minus8+Prob.Prob_minus10_minus9+Prob.Prob_leq_minus10;
    
Prob.Prob_0_1=Prob.Prob_0_1/sumi;
Prob.Prob_1_2=Prob.Prob_1_2/sumi;
Prob.Prob_2_3=Prob.Prob_2_3/sumi;
Prob.Prob_3_4=Prob.Prob_3_4/sumi;
Prob.Prob_4_5=Prob.Prob_4_5/sumi;
Prob.Prob_5_6=Prob.Prob_5_6/sumi;
Prob.Prob_6_7=Prob.Prob_6_7/sumi;
Prob.Prob_7_8=Prob.Prob_7_8/sumi;
Prob.Prob_8_9=Prob.Prob_8_9/sumi;
Prob.Prob_9_10=Prob.Prob_9_10/sumi;
Prob.Prob_geq_10=Prob.Prob_geq_10/sumi;

Prob.Prob_minus1_0=Prob.Prob_minus1_0/sumi;
Prob.Prob_minus2_minus1=Prob.Prob_minus2_minus1/sumi;
Prob.Prob_minus3_minus2=Prob.Prob_minus3_minus2/sumi;
Prob.Prob_minus4_minus3=Prob.Prob_minus4_minus3/sumi;
Prob.Prob_minus5_minus4=Prob.Prob_minus5_minus4/sumi;
Prob.Prob_minus6_minus5=Prob.Prob_minus6_minus5/sumi;
Prob.Prob_minus7_minus6=Prob.Prob_minus7_minus6/sumi;
Prob.Prob_minus8_minus7=Prob.Prob_minus8_minus7/sumi;
Prob.Prob_minus9_minus8=Prob.Prob_minus9_minus8/sumi;
Prob.Prob_minus10_minus9=Prob.Prob_minus10_minus9/sumi;
Prob.Prob_leq_minus10=Prob.Prob_leq_minus10/sumi;

end
