%   CALCULATE_PROB

%   Given the set of scores and labels for each classifier, it discretize 
%   my probability space (ino the intervals of length .1) and calculate the
%   probability of each class in the presence of other class in that bin.

%   AUTHOR: Dhurv Kumar Yadav
function [Prob_Pos, Prob_Neg]=calculate_Prob(scores, labels)
Array=[scores; labels];
Total_Pos=numel(find(Array(2,:)==1));
Total_Neg=numel(find(Array(2,:)==-1));

Pos= numel(find(Array(1,:)<0.1 & Array(1,:)>=0 & Array(2,:)==1));
Neg= numel(find(Array(1,:)<0.1 & Array(1,:)>=0 & Array(2,:)==-1));
Prob_Pos.Prob_0_1=Pos/Total_Pos;
Prob_Neg.Prob_0_1=Neg/Total_Neg;

Pos= numel(find(Array(1,:)<0.2 & Array(1,:)>=0.1 & Array(2,:)==1));
Neg= numel(find(Array(1,:)<0.2 & Array(1,:)>=0.1 & Array(2,:)==-1));
Prob_Pos.Prob_1_2=Pos/Total_Pos;
Prob_Neg.Prob_1_2=Neg/Total_Neg;

Pos= numel(find(Array(1,:)<0.3 & Array(1,:)>=0.2 & Array(2,:)==1));
Neg= numel(find(Array(1,:)<0.3 & Array(1,:)>=0.2 & Array(2,:)==-1));
Prob_Pos.Prob_2_3=Pos/Total_Pos;
Prob_Neg.Prob_2_3=Neg/Total_Neg;

Pos= numel(find(Array(1,:)<0.4 & Array(1,:)>=0.3 & Array(2,:)==1));
Neg= numel(find(Array(1,:)<0.4 & Array(1,:)>=0.3 & Array(2,:)==-1));
Prob_Pos.Prob_3_4=Pos/Total_Pos;
Prob_Neg.Prob_3_4=Neg/Total_Neg;

Pos= numel(find(Array(1,:)<0.5 & Array(1,:)>=0.4 & Array(2,:)==1));
Neg= numel(find(Array(1,:)<0.5 & Array(1,:)>=0.4 & Array(2,:)==-1));
Prob_Pos.Prob_4_5=Pos/Total_Pos;
Prob_Neg.Prob_4_5=Neg/Total_Neg;

Pos= numel(find(Array(1,:)<0.6 & Array(1,:)>=0.5 & Array(2,:)==1));
Neg= numel(find(Array(1,:)<0.6 & Array(1,:)>=0.5 & Array(2,:)==-1));
Prob_Pos.Prob_5_6=Pos/Total_Pos;
Prob_Neg.Prob_5_6=Neg/Total_Neg;

Pos= numel(find(Array(1,:)<0.7 & Array(1,:)>=0.6 & Array(2,:)==1));
Neg= numel(find(Array(1,:)<0.7 & Array(1,:)>=0.6 & Array(2,:)==-1));
Prob_Pos.Prob_6_7=Pos/Total_Pos;
Prob_Neg.Prob_6_7=Neg/Total_Neg;

Pos= numel(find(Array(1,:)<0.8 & Array(1,:)>=0.7 & Array(2,:)==1));
Neg= numel(find(Array(1,:)<0.8 & Array(1,:)>=0.7 & Array(2,:)==-1));
Prob_Pos.Prob_7_8=Pos/Total_Pos;
Prob_Neg.Prob_7_8=Neg/Total_Neg;

Pos= numel(find(Array(1,:)<0.9 & Array(1,:)>=0.8 & Array(2,:)==1));
Neg= numel(find(Array(1,:)<0.9 & Array(1,:)>=0.8 & Array(2,:)==-1));
Prob_Pos.Prob_8_9=Pos/Total_Pos;
Prob_Neg.Prob_8_9=Neg/Total_Neg;

Pos= numel(find(Array(1,:)<1 & Array(1,:)>=0.9 & Array(2,:)==1));
Neg= numel(find(Array(1,:)<1 & Array(1,:)>=0.9 & Array(2,:)==-1));
Prob_Pos.Prob_9_10=Pos/Total_Pos;
Prob_Neg.Prob_9_10=Neg/Total_Neg;

Pos= numel(find(Array(1,:)>=1 & Array(2,:)==1));
Neg= numel(find(Array(1,:)>=1 & Array(2,:)==-1));
Prob_Pos.Prob_geq_10=Pos/Total_Pos;
Prob_Neg.Prob_geq_10=Neg/Total_Neg;





Pos= numel(find(Array(1,:)<0 & Array(1,:)>=-0.1 & Array(2,:)==1));
Neg= numel(find(Array(1,:)<0 & Array(1,:)>=-0.1 & Array(2,:)==-1));
Prob_Pos.Prob_minus1_0=Pos/Total_Pos;
Prob_Neg.Prob_minus1_0=Neg/Total_Neg;

Pos= numel(find(Array(1,:)<-0.1 & Array(1,:)>=-0.2 & Array(2,:)==1));
Neg= numel(find(Array(1,:)<-0.1 & Array(1,:)>=-0.2 & Array(2,:)==-1));
Prob_Pos.Prob_minus2_minus1=Pos/Total_Pos;
Prob_Neg.Prob_minus2_minus1=Neg/Total_Neg;

Pos= numel(find(Array(1,:)<-0.2 & Array(1,:)>=-0.3 & Array(2,:)==1));
Neg= numel(find(Array(1,:)<-0.2 & Array(1,:)>=-0.3 & Array(2,:)==-1));
Prob_Pos.Prob_minus3_minus2=Pos/Total_Pos;
Prob_Neg.Prob_minus3_minus2=Neg/Total_Neg;

Pos= numel(find(Array(1,:)<-0.3 & Array(1,:)>=-0.4 & Array(2,:)==1));
Neg= numel(find(Array(1,:)<-0.3 & Array(1,:)>=-0.4 & Array(2,:)==-1));
Prob_Pos.Prob_minus4_minus3=Pos/Total_Pos;
Prob_Neg.Prob_minus4_minus3=Neg/Total_Neg;

Pos= numel(find(Array(1,:)<-0.4 & Array(1,:)>=-0.5 & Array(2,:)==1));
Neg= numel(find(Array(1,:)<-0.4 & Array(1,:)>=-0.5 & Array(2,:)==-1));
Prob_Pos.Prob_minus5_minus4=Pos/Total_Pos;
Prob_Neg.Prob_minus5_minus4=Neg/Total_Neg;

Pos= numel(find(Array(1,:)<-0.5 & Array(1,:)>=-0.6 & Array(2,:)==1));
Neg= numel(find(Array(1,:)<-0.5 & Array(1,:)>=-0.6 & Array(2,:)==-1));
Prob_Pos.Prob_minus6_minus5=Pos/Total_Pos;
Prob_Neg.Prob_minus6_minus5=Neg/Total_Neg;

Pos= numel(find(Array(1,:)<-0.6 & Array(1,:)>=-0.7 & Array(2,:)==1));
Neg= numel(find(Array(1,:)<-0.6 & Array(1,:)>=-0.7 & Array(2,:)==-1));
Prob_Pos.Prob_minus7_minus6=Pos/Total_Pos;
Prob_Neg.Prob_minus7_minus6=Neg/Total_Neg;

Pos= numel(find(Array(1,:)<-0.7 & Array(1,:)>=-0.8 & Array(2,:)==1));
Neg= numel(find(Array(1,:)<-0.7 & Array(1,:)>=-0.8 & Array(2,:)==-1));
Prob_Pos.Prob_minus8_minus7=Pos/Total_Pos;
Prob_Neg.Prob_minus8_minus7=Neg/Total_Neg;

Pos= numel(find(Array(1,:)<-0.8 & Array(1,:)>=-0.9 & Array(2,:)==1));
Neg= numel(find(Array(1,:)<-0.8 & Array(1,:)>=-0.9 & Array(2,:)==-1));
Prob_Pos.Prob_minus9_minus8=Pos/Total_Pos;
Prob_Neg.Prob_minus9_minus8=Neg/Total_Neg;

Pos= numel(find(Array(1,:)<-0.9 & Array(1,:)>=-1 & Array(2,:)==1));
Neg= numel(find(Array(1,:)<-0.9 & Array(1,:)>=-1 & Array(2,:)==-1));
Prob_Pos.Prob_minus10_minus9=Pos/Total_Pos;
Prob_Neg.Prob_minus10_minus9=Neg/Total_Neg;

Pos= numel(find(Array(1,:)<-1  & Array(2,:)==1));
Neg= numel(find(Array(1,:)<-1  & Array(2,:)==-1));
Prob_Pos.Prob_leq_minus10=Pos/Total_Pos;
Prob_Neg.Prob_leq_minus10=Neg/Total_Neg;

Prob_Pos=Normalise(Prob_Pos);
Prob_Neg=Normalise(Prob_Neg);
clear Array Total_Pos Total_Neg Pos Neg;
end
